//----------------------------------------------------------------------------
#ifndef ChildWinH
#define ChildWinH
//----------------------------------------------------------------------------
#include <Controls.hpp>
#include <Forms.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
#include <StdCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <XPMan.hpp>
#include <ActnList.hpp>
#include <Dialogs.hpp>

#define XY_CLICK_OFF	4
#define XY_MARK_OFF		1
#define DEF_STEP100		4000

typedef struct STLIST
{
	int x;
	int y;
	STLIST *next;
} STLIST;


typedef struct CORDLIST
{
	int x;
	int y;
	int z;
	int a;
	int sp;
	CORDLIST *next;
	CORDLIST *prev;
} CORDLIST;

typedef struct PLTLIST
{
	int rec_x;
	int rec_y;
	int rec_x1;
	int rec_y1;
	int pen;
	int del;
	int mark;
	CORDLIST *cord;
	CORDLIST *cordl;
	PLTLIST *next;
} PLTLIST;

//----------------------------------------------------------------------------
class TMDIChild : public TForm
{
__published:
	TStatusBar *StatusBar1;
	TPaintBox *PaintBox1;
	TScrollBar *ScrollBar1;
	TScrollBar *ScrollBar2;
	TToolBar *ToolBar1;
	TToolButton *ToolButton1;
	TToolButton *ToolButton6;
	TToolButton *ToolButton7;
	TToolButton *ToolButton10;
	TToolButton *ToolButton15;
	TImageList *ImageList1;
	TToolButton *ToolButton2;
	TPanel *Panel1;
	TLabel *Label1;
	TEdit *Edit1;
	TPaintBox *PaintBox2;
	TButton *Button1;
	TToolButton *ToolButton3;
	TActionList *ActionList1;
	TAction *Save;
	TSaveDialog *SaveDialog1;
	TToolButton *ToolButton4;

	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall PaintBox1Paint(TObject *Sender);
	void __fastcall PaintBox1MouseMove(TObject *Sender, TShiftState Shift, int X,
		  int Y);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall FormMouseWheel(TObject *Sender, TShiftState Shift,
		  int WheelDelta, TPoint &MousePos, bool &Handled);
	void __fastcall ScrollBar1Scroll(TObject *Sender, TScrollCode ScrollCode,
		  int &ScrollPos);
	void __fastcall ScrollBar2Scroll(TObject *Sender, TScrollCode ScrollCode,
		  int &ScrollPos);
	void __fastcall ToolButton1Click(TObject *Sender);
	void __fastcall ToolButton6Click(TObject *Sender);
	void __fastcall ToolButton7Click(TObject *Sender);
	void __fastcall PaintBox1MouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall PaintBox1MouseUp(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall PaintBox1MouseLeave(TObject *Sender);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall ToolButton10Click(TObject *Sender);
	void __fastcall ToolButton15Click(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall PaintBox1Click(TObject *Sender);
	void __fastcall ToolButton2Click(TObject *Sender);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall PaintBox2Paint(TObject *Sender);
	void __fastcall PaintBox2MouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall PaintBox2MouseUp(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall PaintBox2MouseMove(TObject *Sender, TShiftState Shift, int X,
		  int Y);
	void __fastcall Button1Click(TObject *Sender);
	void __fastcall ToolButton3Click(TObject *Sender);
	void __fastcall FormKeyUp(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
	void __fastcall SaveExecute(TObject *Sender);
	void __fastcall ToolButton4Click(TObject *Sender);
private:
	int CurrX;
	int CurrY;
	int lastpen;
	int is_crosshair;
	int dis_crosshair;
	int area_x;
	int area_y;
	int area_x1;
	int area_y1;
	int smX, smY,amX, amY,smShift;
	int marked;
	int is_marked;
	int is_mess_down;
	double zoom;
	int step100;
	int point0_x;
	int point0_y;
	int point0_typ;

public:
	virtual __fastcall TMDIChild(TComponent *Owner);
	void __fastcall load_plt(TPaintBox *dst, String name);
	void __fastcall load_plt_file(char *fname);
	void __fastcall draw_plt(int x, int y , int z, int a, int sp,int fl);
	void __fastcall save_plt_file(char *fname);

	PLTLIST *pltlist;
	PLTLIST *pltlast;

	STLIST *stlist;

	void DrawCrossHairs(void);
	void PLT_add(void);
	void calc_zoom(void);
	void PLT_add_draw(int x, int y, int z, int a, int sp, PLTLIST *cur);
	void transform(int *x, int *y);
	void DrawMarkShape(void);
	void to_real(int *x, int *y);
	void clean_plt(void);
	void transform_save(int *ex, int *ey);
	void PaintPoint0(void);
	void PaintPoint0_line(int x, int y, int lx, int ly);
	void PaintPLTList(PLTLIST * pnext);
	void PaintSTList(STLIST * stnext);
	void ST_add(int x, int y);
	void ST_rm(int x, int y);
	void rmCrossHairs(void);
	void PaintMark(int x, int y);
	boolean find_lpoint(int *x3, int *y3);
	boolean find_lpoint_pos(int x1, int y1, int x2, int y2, int snap, int *x3, int *y3);
	boolean split_line(int x, int y, int width, int x1, int y1, int x2, int y2, int *xa, int *ya, int *xb, int *yb);
};
//----------------------------------------------------------------------------
#endif

